|
请使用QQ关联注册PLM之家,学习更多关于内容,更多精彩原创视频供你学习!
您需要 登录 才可以下载或查看,没有账号?注册
x
3 E O2 x) a: `3 G* N3 i% B2 i3 t# c
UG NX 二次开发 CAM 二次开发思路及过程' j+ `' V) o' m x# U
/ j4 E, q3 I t! z; U$ h8 k5 R* M% }0 Z
1. 获取当前Session:Session *theSession = Session::GetSession();
2 P7 J$ c! X4 Z9 w, T# o! b. T2. 创建文件或者打开的文件,可使用Session的方法或者直接使用UF_PART_ask_display_part()等;2 K/ |( t0 C- m4 u
3. 创建CAM环境: 8 M" c% K: _( a* ~: L
1)进入CAM模块,即创建CAMSession:theSession->CreateCamSession(); * y$ u9 ?$ g' p
2)初始化CAM,创建CAMSetup:CAM::CAMSetup *cAMSetup = workPart->CreateCamSetup("mill_planar");
o6 T( ?) @; s2 l- \4. 创建刀具,程序、机床、方法(四个GROUP),以刀具为例(使用UF_CAM_create_tool方法也可以创建刀具): 1)取默认的刀具group的父group: CAM::NCGroup*nCGroupP(dynamic_cast<CAM::NCGroup*>(cAMSetup->CAMGroupCollection()->FindObject("GENERIC_MACHINE"))); # I" ^6 R4 f; W- [/ s% f$ x: ?# s
2)调用CAMGroupCollection的CreateTool方法创建刀具: 4 W* e4 W8 F+ ]
CAM::NCGroup *nCGroupTool= cAMSetup->CAMGroupCollection()->CreateTool(nCGroupP, "mill_planar", "MILL",CAM::NCGroupCollection::UseDefaultNameFalse, "jorbinMIll"); 8 U4 E* Q" U5 |( C
3)修改刀具参数,根据刀具的类型由对应的ToolBuilder修改刀具参数(这和UF函数和NXOpen混合开放思路一样,UF函数易于创建对象,NXOpen的Builder易于修改对象参数): ) w' j% P+ ~' z+ y8 C- ~2 @8 t$ K) H
CAM::Tool *Milltool(dynamic_cast<CAM::Tool *>(nCGroupTool));$ ~5 |1 L3 Y+ @, q. d0 j
CAM::MillToolBuilder *millToolBuilder = cAMSetup->CAMGroupCollection()->CreateMillToolBuilder(Milltool); millToolBuilder->TlHeightBuilder()->SetValue(100.0); millToolBuilder->TlDiameterBuilder()->SetValue(44.0); NXObject *nXObject = millToolBuilder->Commit(); millToolBuilder->Destroy();, K! N4 d& i! Q/ R1 ?9 h: u
5. 创建操作: $ _/ a1 i9 ~4 Z1 o6 Y P$ k9 X
1) 创建操作:8 s! [* P8 i/ Y' b% ^4 Z$ _
CAM::Operation *operation = cAMSetup->CAMOperationCollection()->Create(nCGroup1, nCGroup2, nCGroup3, nCGroup4, "mill_planar", "FACE_MILLING_AREA", CAM::OperationCollection::UseDefaultNameFalse, "FACE_MILLING_AREA_JORBIN_GAO");
5 |' ?1 R4 M. B8 M. G 2)修改参数,和修改刀具参数类似,通过对应的Builder完成: $ Q T3 b I* K, h8 I
CAM::FaceMillingBuilder *faceMillingBuilder = cAMSetup->CAMOperationCollection()->CreateFaceMillingBuilder(operation); faceMillingBuilder->FeedsBuilder()->FeedPerToothBuilder()->SetValue(10.0); NXObject *nXOpObject = faceMillingBuilder->Commit(); faceMillingBuilder->Destroy(); $ x2 l1 f# ]2 M7 t
) ?+ V V$ h$ Z( m& W' X 注意:; `9 P5 T) b- W1 @2 a9 x6 Y6 t
1)操作过程通过设置适度的SetUndoMark()和DeleteUndoMark()保证程序的健壮性。 2)dynamic_cast强制转换运算符将一个基类的指针或者引用转换为其子类的指针或者引用,其使用方法为:dynamic<type>(object)。 3)对上述代码有不清楚的请参阅NXOpen的文档或者自己录制Journal比较查看。
" V, ?. \. _ a! l, l& U4 r
5 [9 ]7 t+ @2 O; b) V9 h0 O
7 p- f. z! a* A8 o& h% X |
|